import { EventEmitter, OnInit } from '@angular/core';
import { NgbCalendar, NgbDate, NgbDateParserFormatter, NgbDatepicker, NgbDropdown } from '@ng-bootstrap/ng-bootstrap';
import { Moment } from 'moment-mini';
import { DateRangeChange } from '../../models/date-range-change';
import { DateRangePickerUtils } from '../../utils/date-ranges-utils';
import * as i0 from "@angular/core";
export declare class DateRangePickerComponent implements OnInit {
    private dateRangePickerUtils;
    private calendar;
    formatter: NgbDateParserFormatter;
    /**
     * The default date range option to show.
     * @default DATE_RANGE_OPTIONS.Last28Days
     */
    dateRangeKey: string;
    /**
     * The CSS class to apply to the "Apply" button.
     * @default 'btn-primary'
     */
    btnApplyClass: string;
    /**
     * The CSS class to apply to the date range picker.
     * @default ''
     */
    pickerCustomClass: string;
    /**
     * Emitted when the date range selection is changed.
     */
    readonly rangeChanged: EventEmitter<DateRangeChange>;
    dateRangerPicker: NgbDatepicker | undefined;
    dropdown: NgbDropdown | undefined;
    selectedDateRangeKey: string;
    selectedDateRangeTempKey: string;
    selectedRangeLabel: string;
    selectedRangeDateLabel: string;
    selectedRangeTempLabel: string;
    selectedDateRange: string;
    hoveredDate: NgbDate | null;
    startNgbDate: NgbDate;
    endNgbDate: NgbDate | null;
    startDate: Moment;
    endDate: Moment;
    dateRangeOptions: {
        key: string;
        value: string;
    }[];
    constructor(dateRangePickerUtils: DateRangePickerUtils, calendar: NgbCalendar, formatter: NgbDateParserFormatter);
    ngOnInit(): void;
    isHovered(date: NgbDate): boolean | null;
    onDateSelection(date: NgbDate): void;
    isInside(date: NgbDate): boolean | null;
    isRange(date: NgbDate): boolean | null;
    validateInput(currentValue: NgbDate | null, input: string): NgbDate | null;
    changeDateRange(rangeKey: string, event: Event): void;
    cancel(): void;
    isActiveRange(range: string): boolean;
    apply(): void;
    private setRange;
    private emitRangeChanged;
    static ɵfac: i0.ɵɵFactoryDeclaration<DateRangePickerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DateRangePickerComponent, "app-date-range-picker", never, { "dateRangeKey": { "alias": "dateRangeKey"; "required": false; }; "btnApplyClass": { "alias": "btnApplyClass"; "required": false; }; "pickerCustomClass": { "alias": "pickerCustomClass"; "required": false; }; }, { "rangeChanged": "rangeChanged"; }, never, never, false, never>;
}
